<html>
<head><title>request replay test</title></head>
<body>
<form action="submit" method="post" target="target1" id="module1_form">
    <input type="hidden" name="form_id" value="module1_form">
    <input type="text" name="msg" value="test">
    <button id="module1_form_submit">send</button>
</form>
<iframe name="target1"></iframe>
<script>
    const extension_id = () => document.body.getAttribute('extension_id')
    const debug = true
    const log = debug ? console.log : (m) => {}
    // wir sind hier nicht auf der jagd nach der letzten millisekunde ;)
    // sollten wir es sein, sollten wir die notwendigkeit für diesen kunstgriff beseitigen
    const retry_delay = 75

    const request_submit = (form_id) => {
        return (e) => {
            log('button clicked')
            e.preventDefault()
            retry_till_success(form_id)
            return false
        }
    }

    const delete_state = (form_id) => {
        chrome.runtime.sendMessage(
            extension_id(),
            {msg_type: 'delete_state', data: {form_id: form_id}},
            (r) => {
                log(r)
            }
        )
    }

    function sendMessage(tabId, item) {
        return new Promise((resolve, reject) => {
            chrome.runtime.sendMessage(tabId, item, response => {
                resolve(response, 1234)
            })
        })
    }

    function sleep(milliseconds) {
        return new Promise(resolve => setTimeout(resolve, milliseconds));
    }

    const retry_till_success = async (form_id) => {
        log('do submit')
        let state = 'nothing'
        let nextState = 'init'
        while (1) {
            log('check success')

            if (state == 'init') {
                document.getElementById(form_id).submit()
                nextState = 'request'
            }

            if (state == 'request') {
                let r = await sendMessage(extension_id(), {msg_type: 'get_state', data: {form_id: form_id}})
                log(r)
                if (r.state.state == 'success') nextState = 'done'
                if (r.state.state == 'failed') nextState = 'init'
            }

            if (state == 'done') {
                let r = await sendMessage(extension_id(), {msg_type: 'delete_state', data: {form_id: form_id}})
                log(r)
                return
            }

            state = nextState
            await sleep(retry_delay)
        }
    }
    document.getElementById('module1_form_submit').addEventListener('click', request_submit('module1_form'))
</script>
</body>
</html>